diff -r 11a8f1275a38 sys/netinet/mptcp_subr.c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_subr.c	Mon Mar 11 02:59:51 2013 +1100
@@ -0,0 +1,1024 @@
+/*-
+ * Copyright (c) 2012-2013
+ * 	Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams and
+ * Lawrence Stewart, made possible in part by a gift from The Cisco University
+ * Research Program Fund, a corporate advised fund of Silicon Valley Community
+ * Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include "opt_compat.h"
+#include "opt_inet.h"
+#include "opt_inet6.h"
+#include "opt_ipsec.h"
+#include "opt_tcpdebug.h"
+
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/param.h>
+#include <sys/queue.h>
+#include <sys/systm.h>
+#include <sys/callout.h>
+#include <sys/hhook.h>
+#include <sys/kernel.h>
+#include <sys/khelp.h>
+#include <sys/kdb.h>
+#include <sys/lock.h>
+#include <sys/rwlock.h>
+#include <sys/sysctl.h>
+#include <sys/sbuf.h>
+#include <sys/taskqueue.h>
+#include <sys/jail.h>
+
+#ifdef INET6
+#include <sys/domain.h>
+#endif
+#include <sys/priv.h>
+#include <sys/proc.h>
+#include <sys/sockbuf.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+#include <sys/protosw.h>
+#include <sys/random.h>
+
+/* for SCTP auth functions */
+#include <crypto/sha1.h>
+
+#include <netinet/in.h>
+#include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/tcp_timer.h>
+#include <netinet/tcp_fsm.h>
+
+/* for SCTP auth functions */
+#include <netinet/sctp_pcb.h>
+#include <netinet/sctp_auth.h>
+#include <netinet/sctp_constants.h>
+
+#include <machine/stdarg.h>
+
+/* Declare sysctl tree and populate it. */
+SYSCTL_NODE(_net_inet_tcp, OID_AUTO, mptcp, CTLFLAG_RW, NULL,
+    "Mulitpath TCP related settings");
+
+VNET_DEFINE(int, linux_compat) = 1;
+#define	V_mptcp_linux_compat	VNET(mptcp_linux_compat);
+SYSCTL_VNET_INT(_net_inet_tcp_mptcp, OID_AUTO, linux_compat, CTLFLAG_RW,
+    &VNET_NAME(linux_compat), 0,
+    "Enable hacks for linux mptcp compatability");
+
+VNET_DEFINE(int, max_subflows) = 8;
+#define	V_mptcp_max_subflows	VNET(mptcp_max_subflows);
+SYSCTL_VNET_INT(_net_inet_tcp_mptcp, OID_AUTO, max_subflows, CTLFLAG_RW,
+    &VNET_NAME(max_subflows), 0,
+    "Maximum number of subflows per Multipath TCP Connection");
+
+VNET_DEFINE(int, tcp_do_autosndbuf) = 1;
+#define	V_tcp_do_autosndbuf	VNET(tcp_do_autosndbuf)
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_auto, CTLFLAG_RW,
+	&VNET_NAME(tcp_do_autosndbuf), 0,
+	"Enable automatic send buffer sizing");
+
+VNET_DEFINE(int, tcp_autosndbuf_inc) = 8*1024;
+#define	V_tcp_autosndbuf_inc	VNET(tcp_autosndbuf_inc)
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_inc, CTLFLAG_RW,
+	&VNET_NAME(tcp_autosndbuf_inc), 0,
+	"Incrementor step size of automatic send buffer");
+
+VNET_DEFINE(int, tcp_autosndbuf_max) = 2*1024*1024;
+#define	V_tcp_autosndbuf_max	VNET(tcp_autosndbuf_max)
+SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_max, CTLFLAG_RW,
+	&VNET_NAME(tcp_autosndbuf_max), 0,
+	"Max size of automatic send buffer");
+
+struct debug_class {
+	char class[32];
+	int verbosity;
+};
+
+uint32_t mp_active_debug_classes;
+
+#define	N_DEBUGCLASSES 3
+struct debug_class debug_classes[N_DEBUGCLASSES] = {
+		{.class = "MPSESSION"},
+		{.class = "DSMAP"},
+		{.class = "SBSTATUS"}
+};
+
+//struct ds_map*
+//mp_get_dsmap(struct tcpcb *tp, uint64_t ds_ack_num);
+
+/* keeping track of addresses added via sysctl: */
+/* net.inet.tcp.mptcp.mp_addresses */
+int mp_address_count = 0;
+struct sockaddr_storage mp_usable_addresses[MAX_ADDRS];
+
+/* Initialise extern variables that store addresses */
+struct sockaddr_storage mp_path_manager[MAX_ADDRS];
+
+#define MSBIT_CHECK 0x80000000
+
+
+void
+mp_debug(uint32_t log_class, int msg_verbosity, uint32_t flags, char * fmt, ...) {
+	va_list ap;
+	int effective_verbosity, i;
+
+	effective_verbosity = 0;
+
+	if (log_class & mp_active_debug_classes) {
+	// calculate shift index (index of class into array)
+		i = 0;
+		while(log_class >= 1) {
+			if (log_class & 0x1)
+				effective_verbosity = max(debug_classes[i].verbosity, effective_verbosity);
+			log_class >>= 1;
+			i++;
+		}
+
+		if	(msg_verbosity <= effective_verbosity) {
+			va_start(ap, fmt);
+			vprintf(fmt, ap);
+			va_end(ap);
+		}
+	}
+}
+
+/*
+ * Sysctl handler to show and change slave subflow addresses
+ */
+static int
+mp_addresses(SYSCTL_HANDLER_ARGS)
+{
+	char *straddr;
+	struct sbuf *s;
+	void *addr;
+	char inet_buf[64];
+	int error, i, ret;
+
+	error = 0;
+
+	if (req->newptr == NULL) {
+
+		s = sbuf_new_for_sysctl(NULL, NULL, 300, req);
+		if (s == NULL)
+			return (ENOMEM);
+
+		for (i = 0; i < mp_address_count; i++) {
+			switch (mp_usable_addresses[i].ss_family) {
+				case AF_INET:
+					addr = &((struct sockaddr_in *)
+					    &mp_usable_addresses[i])->sin_addr;
+					break;
+				case AF_INET6:
+					addr = &((struct sockaddr_in6 *)
+					    &mp_usable_addresses[i])->sin6_addr;
+					break;
+				default:
+					return (EINVAL);
+			}
+
+			inet_ntop(mp_usable_addresses[i].ss_family, addr, inet_buf,
+			    mp_usable_addresses[i].ss_len);
+			sbuf_cat(s, inet_buf);
+			if (i < (mp_address_count - 1))
+				sbuf_cat(s, " ");
+		}
+
+		error = sbuf_finish(s);
+		sbuf_delete(s);
+	} else {
+		i = 0;
+		while ((straddr = strsep((char **)&req->newptr, " ")) != NULL && i < MAX_ADDRS && !error) {
+			ret = inet_pton(AF_INET6, straddr, &((struct sockaddr_in6 *)&mp_usable_addresses[i])->sin6_addr);
+			if (ret == 1) {
+				mp_usable_addresses[i].ss_family = AF_INET6;
+				mp_usable_addresses[i].ss_len = sizeof(struct sockaddr_in6);
+			} else if (ret == 0) {
+				ret = inet_pton(AF_INET, straddr, &((struct sockaddr_in *)&mp_usable_addresses[i])->sin_addr);
+				if (ret == 1) {
+					mp_usable_addresses[i].ss_family = AF_INET;
+					mp_usable_addresses[i].ss_len = sizeof(struct sockaddr_in);
+				}
+			}
+
+			if (ret < 1) {
+				error = EINVAL;
+				mp_address_count = 0; //XXX: We shouldn't be reading into mp_usable_addresses directly...
+			}
+			i++;
+		}
+
+		if (!error) {
+			if (i == mp_address_count)
+				error = E2BIG;
+			else
+				mp_address_count = i;
+		}
+	}
+
+	return (error);
+}
+
+/*
+ * Sysctl handler for setting debug output levels for mp
+ */
+static int
+mp_debug_sysctl_handler(SYSCTL_HANDLER_ARGS)
+{
+	struct sbuf *s;
+	int error, i;
+
+	error = 0;
+
+	if (req->newptr == NULL) {
+		s = sbuf_new_for_sysctl(NULL, NULL, 300, req);
+		if (s == NULL)
+			return (ENOMEM);
+
+		for(i = 0; i < N_DEBUGCLASSES; i++) {
+				if (i > 0)
+					sbuf_putc(s, ',');
+				sbuf_printf(s, "%s:%d", debug_classes[i].class, debug_classes[i].verbosity);
+		}
+
+		error = sbuf_finish(s);
+		sbuf_delete(s);
+	} else {
+		char *class, *pair;
+
+		while ((pair = strsep(((char **)&req->newptr), ",")) != NULL) {
+			class = strsep(&pair, ":");
+			for(i = 0; i < N_DEBUGCLASSES; i++) {
+				if (strcmp(class, debug_classes[i].class) == 0
+					|| strcmp(class, "ALL") == 0) {
+					debug_classes[i].verbosity = strtol(pair, NULL, 10);
+					if (debug_classes[i].verbosity == 0)
+						mp_active_debug_classes &= ~(1<<i);
+					else
+						mp_active_debug_classes |= 1<<i;
+				}
+			}
+		}
+	}
+
+	return (error);
+}
+
+/*
+ * Some basic random number/hashing functions that should
+ * be okay for initial release
+ *
+ * XXXNJW: Need a more secure method?
+ */
+u_int64_t
+mp_generate_local_key(void)
+{
+       u_int64_t key = arc4random();
+       key = key << 32;
+       key += arc4random();
+       return key;
+}
+
+/*
+ * Digest is for a 20 byte SHA1, key is the session key created
+ * when the mpcb was created
+ */
+uint32_t
+mp_do_sha_hash(uint8_t *digest, uint8_t *key, uint64_t key_length) {
+
+       SHA1_CTX context;
+
+       if ((key == NULL) || (key_length == 0)) {
+              return (0);
+       }
+
+       SHA1Init(&context);
+       SHA1Update(&context, key, key_length);
+       SHA1Final(digest, &context);
+
+       return key_length;
+}
+
+// XXXNJW: turn these into Macros
+/*
+ * Take a digest and return a token. Linux_compat
+ * changes the offset into the digest.
+ */
+uint32_t
+mp_get_token(uint8_t *digest) {
+	if(!linux_compat)
+		return (*((uint32_t *) (digest + 16)));
+	else
+		return (*((uint32_t *) (digest)));
+}
+
+/*
+ * Take a digest and return the idsn. Linux_compat
+ * changes the offset into the digest.
+ */
+
+uint64_t
+mp_new_idsn(uint8_t *digest) {
+	if(!linux_compat)
+		return (*((uint64_t *) (digest)));
+	else
+		return (*((uint64_t *) (digest+12)));
+}
+
+/*
+ * HMAC for used when completing mp_join handshake
+ */
+uint32_t
+mp_get_hmac(uint8_t *digest, struct mpcb *mp, struct tcpcb *tp) {
+	/*
+	* Set up the hmac key
+	*/
+	uint32_t keylen = sizeof(mp->local_key);
+	uint8_t *key_1_ptr;
+	uint8_t *key_2_ptr;
+	sctp_key_t *key_1;
+	sctp_key_t *key_2;
+
+	key_1 = sctp_alloc_key(keylen);
+	key_1->keylen = keylen;
+	key_1_ptr = key_1->key;
+	bcopy(&mp->local_key, key_1_ptr, keylen);
+
+	key_2 = sctp_alloc_key(keylen);
+	key_2->keylen = keylen;
+	key_2_ptr = key_2->key;
+	bcopy(&mp->remote_key, key_1_ptr, keylen);
+
+	sctp_key_t *hmac_key;
+	hmac_key = sctp_compute_hashkey(key_1, key_2, NULL);
+
+	/*
+	* Set up the hmac msg
+	*/
+	uint64_t hmac_msg;
+	hmac_msg = ((uint64_t)tp->local_rand << 32);
+	hmac_msg |= tp->remote_rand;
+
+	uint32_t hmac_len = sctp_compute_hmac(0x0001, 					//SCTP_HMAC
+			hmac_key, (uint8_t*) &hmac_msg, sizeof(hmac_msg), digest);
+
+	return(hmac_len);
+}
+
+/*
+ * Debugging function for printing a sequence of bytes
+ */
+void
+btohex(char *buf, uint32_t buf_len, uint8_t *bytes, int32_t bytes_len, int32_t flags)
+{
+	struct sbuf out;
+	int32_t i;
+
+	i = bytes_len - 1;
+	sbuf_new(&out, buf, buf_len, 0);
+
+	while (i >= 0) {
+		if (flags & BTOHEX_MSBRTOL)
+			sbuf_printf(&out, "%x", *(bytes + bytes_len - i - 1));
+		else
+			sbuf_printf(&out, "%x", *(bytes + i));
+		i--;
+	}
+
+	sbuf_finish(&out);
+}
+
+void
+mp_get_recwin(unsigned long *recwin) {
+	return;
+}
+
+int
+mp_close_subflows() {
+	//XXXNJW: tdb
+	return (0);
+}
+
+int
+mp_close_subflow(struct tcpcb *tp) {
+	//XXXNJW: tdb
+	return (0);
+}
+
+
+void
+mp_datascheduler_task_handler(void *context, int pending)
+{
+	struct mpcb *mp;
+	struct tcpcb *sf_tp;
+
+	mp = (struct mpcb *)context;
+	KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		INP_WLOCK(sf_tp->t_inpcb);
+		if (!(sf_tp->t_inpcb->inp_flags & INP_DROPPED) && sf_tp->sf_flags & SFF_DATA_WAIT) {
+			tcp_output(sf_tp);
+			INP_WUNLOCK(sf_tp->t_inpcb);
+			break;
+		}
+		INP_WUNLOCK(sf_tp->t_inpcb);
+	}
+}
+
+/*
+ * Pass in mp control block in context
+ * pending == not sure, read the man page
+ *
+ * -tcp_subflow_attach(so,mp)
+ * 	 -> inpcb_alloc_subflow
+ * 	 -> tcp_newtcpcb
+ * - create sockaddr
+ * - tcp_do_subflow_connect(struct tcpcb *tp, struct sockaddr *nam, struct thread *td)
+ */
+
+void mp_join_task_handler(void *context, int pending) {
+	struct inpcb *sf_inp;
+	struct mpcb *mp;
+	struct socket *so;
+	struct tcpcb *tp;
+	struct sockaddr dst_nam;
+	void *laddr;
+	int ret, error;
+
+	mp = (struct mpcb *)context;
+	KASSERT(mp != NULL, ("%s: mp from context was NULL\n", __func__));
+
+	/*
+	 * MAX_SUBFLOWS is not always the same as the
+	 * number of available addresses
+	 */
+	if(!mp->mp_advjoin_mask || mp->subflow_cnt == MAX_SUBFLOWS)
+		return;
+
+	so = mp->master_socket;
+
+	/*
+	 * Find the next address to send a JOIN for, then
+	 * assign this to addr and use when connecting the new
+	 * subflow
+	 */
+	int i;
+	for (i = 0; i < mp_address_count; i++) {
+		/* continue if this index has sent join already */
+		if (!(mp->mp_advjoin_mask & (1 << i)))
+			continue;
+
+		/* Allocate an inp for the subflow */
+		INP_INFO_WLOCK(&V_tcbinfo);
+		sf_inp = in_pcballoc_subflow(so, &V_tcbinfo);
+		INP_INFO_WUNLOCK(&V_tcbinfo);
+
+		if(!sf_inp)
+			goto out;
+
+		switch (mp_usable_addresses[i].ss_family) {
+			case AF_INET:
+				laddr = &((struct sockaddr_in *)
+					&mp_usable_addresses[i])->sin_addr.s_addr;
+				bcopy(laddr, &sf_inp->inp_laddr, 4);
+				break;
+			case AF_INET6:
+				laddr = &((struct sockaddr_in6 *)
+					&mp_usable_addresses[i])->sin6_addr.__u6_addr;
+				bcopy(laddr, &sf_inp->in6p_laddr, 16);
+				break;
+		}
+
+		mp->mp_advjoin_mask &= ~(1 << i);
+
+		/* Use the same local port as the master tp */
+		sf_inp->inp_lport = mp->master_inpcb->inp_lport;
+
+		/* create a tp for the subflow inp */
+		ret = tcp_subflow_attach(so, sf_inp, mp);
+
+		/* destination address from master_inpcb */
+		if(mp->master_inpcb->inp_vflag & INP_IPV4) {
+			bcopy(&mp->master_inpcb->inp_faddr,
+			    &(((struct sockaddr_in *) &dst_nam)->sin_addr.s_addr),
+			    sizeof(struct in_addr));
+			((struct sockaddr_in *) &dst_nam)->sin_port
+			    = mp->master_inpcb->inp_fport;
+			dst_nam.sa_len = sizeof(struct sockaddr_in);
+			dst_nam.sa_family = AF_INET;
+		} else if (mp->master_inpcb->inp_vflag & INP_IPV6) {
+			bcopy(&mp->master_inpcb->in6p_faddr,
+				&(((struct sockaddr_in6 *) &dst_nam)->sin6_addr.__u6_addr),
+				sizeof(struct in6_addr));
+			((struct sockaddr_in6 *) &dst_nam)->sin6_port
+				= mp->master_inpcb->inp_fport;
+			dst_nam.sa_len = sizeof(struct sockaddr_in6);
+			dst_nam.sa_family = AF_INET6;
+		}
+
+		/* ret > 1 if some kind of error */
+		if (ret) {
+			goto free;
+		}
+
+		tp = intotcpcb(sf_inp);
+
+		/* debug output for addresses */
+		char buf[128];
+		inet_ntop(AF_INET, &sf_inp->inp_laddr, buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s: Connecting from %s port %d to ",
+		    __func__, buf, ntohs(sf_inp->inp_lport));
+		inet_ntop(AF_INET, &(((struct sockaddr_in *) &dst_nam)->sin_addr),
+		    buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "%s port %d\n", buf,
+		    ntohs(((struct sockaddr_in *) &dst_nam)->sin_port));
+
+
+		/* Start connection and send the SYN */
+		/*
+		 * XXXNJW: passing the wrong cred here (swi cred rather than master socket cred)
+		 * Should be passing something like 'mp->master_socket->so_cred;'
+		 */
+		error = (*so->so_proto->pr_usrreqs->pru_connect)(so, &dst_nam, curthread);
+		if (error)
+			mp_debug(MPSESSION, 4, 0, "%s: pru_connect error %d\n",
+			    __func__, error);
+
+	}
+
+	goto out;
+
+free:
+	in_pcbfree(sf_inp);
+out:
+	return;
+}
+
+
+void
+mp_data_ack(struct mpcb *mp, uint64_t data_ack_num) {
+
+	mtx_lock(&mp->mpcb_mutex);
+
+	if (data_ack_num > mp->ds_snd_una) {
+		atomic_subtract_int(&mp->master_socket->so_snd.sb_cc,
+		    data_ack_num - mp->ds_snd_una);
+		mp->ds_snd_una = data_ack_num;
+		mp_deferred_sbdrop(mp);
+	} else if (data_ack_num > mp->ds_snd_max
+	      && ((mp->mp_state == MPS_M_FIN_WAIT_1)
+	      || (mp->mp_state == MPS_M_LAST_ACK))) {
+		// issue FINs on all the subflows
+	}
+
+	mtx_unlock(&mp->mpcb_mutex);
+}
+
+void
+mp_init_established(struct tcpcb *tp) {
+
+	/* Enabled multipath features */
+	tp->mp_active = 1;
+
+	/* we know the other end is mp enabled */
+	if (IS_MASTER_TP(tp)) {
+		tp->t_mpcb->mp_state = MPS_ESTABLISHED;
+		tp->t_mpcb->direct_map = 0;
+		tp->t_mpcb->ds_map_max = tp->t_mpcb->ds_snd_una =
+		    tp->t_mpcb->ds_map_min = tp->t_mpcb->ds_idsn;
+		tp->t_mpcb->ds_rcv_nxt = tp->t_mpcb->ds_idsr;
+
+		mp_debug(MPSESSION, 4, 0, "%s: idsn - %ju\n",
+		    __func__, (uintmax_t) tp->t_mpcb->ds_idsn);
+
+		mp_debug(MPSESSION, 4, 0, "%s: local token: %u, remote token: %u\n", __func__,
+			(uint32_t) tp->t_mpcb->local_token,
+			(uint32_t) tp->t_mpcb->remote_token);
+
+		mp_debug(MPSESSION, 4, 0, "%s: local key: %ju, remote key: %ju\n", __func__,
+			(uintmax_t) tp->t_mpcb->local_key,
+			(uintmax_t) tp->t_mpcb->remote_key);
+	} else {
+		mp_debug(MPSESSION, 4, 0, "%s: established slave subflow\n",__func__);
+	}
+
+
+}
+
+void
+mp_deferred_sbdrop(struct mpcb *mp) {
+	struct ds_map *map, *next_map;
+	struct mbuf *cannotfreembptr;
+	int ndrop = 0;
+	uint64_t ds_high_drop, ds_map_end;
+
+	cannotfreembptr = NULL;
+
+	/* Keep a list of maps that should be freed only if ndrop is > 0 */
+	struct dsmapq_head maps_to_free;
+	TAILQ_INIT(&maps_to_free);
+
+	ds_high_drop = 0;
+
+	TAILQ_FOREACH(map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+		ds_map_end = map->ds_map_start + map->ds_map_len;
+
+		mp_debug(DSMAP, 4, 0, "%s: check map %p, ds_map_start: %ju, ds_map_end %ju, ds_snd_una %ju, "
+				"ds_high_drop: %ju, mbuf_start: %p, mbuf_offset: %u, mbuf_len: %d\n",
+				__func__, map, (uintmax_t) map->ds_map_start, (uintmax_t) ds_map_end,
+				(uintmax_t) mp->ds_snd_una, (uintmax_t) ds_high_drop, map->mbuf_start,
+				map->mbuf_offset, map->mbuf_start->m_len);
+
+		/*
+		 * Can we drop this map?
+		 * - Has it been cumulatively ACKED
+		 * - Does the sequence space start and end before ds_snd_una
+		 * - Does the maps data region fall within a single mbuf
+		 *
+		 */
+		if ((map->flags & MAPF_IS_ACKED) && map->ds_map_start < mp->ds_snd_una
+		    && ds_map_end <= mp->ds_snd_una) {
+			if (ds_high_drop == 0)
+				ndrop = map->ds_map_len;
+			else if (ds_high_drop < ds_map_end)
+				ndrop += ds_map_end - ds_high_drop;
+
+			ds_high_drop = ulmax(ds_map_end, ds_high_drop);
+
+			mp_debug(DSMAP, 4, 0, "%s: ds_high_drop: %ju, ndrop: %d, sb_cc: %d\n",
+					__func__, (uintmax_t)ds_high_drop, ndrop, mp->master_socket->so_snd.sb_cc);
+
+			/*
+			 * We are re-using the sf_ds_map_next link as it is no longer
+			 * used at the subflow level (the map is removed from the subflow
+			 * map list before it is marked as MAPF_IS_ACKED).
+			 */
+			TAILQ_INSERT_HEAD(&maps_to_free, map, sf_ds_map_next);
+
+		} else if (map->ds_map_start >= mp->ds_snd_una || map->ds_map_start >= ds_high_drop) {
+
+			/* CHECK mbuf_start + map->mbuf_offset against other maps to be freed
+			 * and only allow free if they won't invalidate other mbuf_offset values.
+			 */
+			cannotfreembptr = map->mbuf_start;
+			mp_debug(DSMAP, 4, 0, "%s: reached end of freeable maps at mbuf %p len %d\n\n",
+			    __func__, cannotfreembptr, cannotfreembptr->m_len);
+			/* The list is ordered based on ascending ds_map_start, therefore maps
+			 * including and after this map cannot be freed. OR This map does not
+			 * overlap with any previous maps therefore it is safe to free up to
+			 * but not including this map. */
+			break;
+		} else {
+			mp_debug(DSMAP, 4, 0, "%s: map overlap below una, can't drop anything\n", __func__);
+			/* We have overlap between a completed and uncompleted map this
+			 * is below una or we have a map that overlaps and extends past
+			 * una */
+
+				ndrop = 0;
+				break;
+		}
+	}
+
+	/* Error as we are dropping more than in the sb */
+	if (ndrop > mp->master_socket->so_snd.sb_actual) {
+			panic("%s: ndrop greater than chars in sendbuffer\n", __func__);
+	}
+
+	if (ndrop > 0) {
+		int bytes_from_end;
+		struct mbuf *map_mbuf_end;
+
+		map = TAILQ_FIRST(&maps_to_free);
+		while (map != NULL) {
+			next_map = TAILQ_NEXT(map, sf_ds_map_next);
+
+			map_mbuf_end = map->mbuf_start;
+			bytes_from_end = map->ds_map_len + map->mbuf_offset;
+			while (bytes_from_end > map_mbuf_end->m_len) {
+				bytes_from_end -= map_mbuf_end->m_len;
+				map_mbuf_end = map_mbuf_end->m_next;
+			}
+
+			if (map_mbuf_end == cannotfreembptr) {
+
+				mp_debug(DSMAP, 4, 0, "%s: snd_dsmap %p TWEAKED - "
+						"bytes_from_end: %d\n", __func__, map, bytes_from_end);
+				mp_debug(DSMAP, 4, 0, "    PRE TWEAK - ndrop: %d, "
+				    "ds_map_start: %ju ds_map_len: %u, mbuf_start: %p, "
+				    "mbuf_offset: %u, mbuf_len: %d ds_high_drop: %ju\n",
+					ndrop, (uintmax_t)map->ds_map_start, map->ds_map_len,
+					map->mbuf_start, map->mbuf_offset, map->mbuf_start->m_len,
+					(uintmax_t)ds_high_drop);
+
+				if(map->mbuf_start != map_mbuf_end) {
+					map->mbuf_start = map_mbuf_end;
+					map->mbuf_offset = 0;
+					map->ds_map_start = map->ds_map_start +
+					    map->ds_map_len - bytes_from_end;
+					map->ds_map_len = bytes_from_end;
+				}
+
+				if (ds_high_drop > map->ds_map_start) {
+					ndrop -= ds_high_drop - map->ds_map_start;
+					KASSERT(ndrop >= 0, ("%s: negative ndrop value - "
+					    "%d\n", __func__, ndrop));
+					ds_high_drop = map->ds_map_start;
+				}
+
+				mp_debug(DSMAP, 4, 0, "    POST TWEAK - ndrop: %d, "
+				    "ds_map_start: %ju ds_map_len: %u, mbuf_start: %p, "
+				    "mbuf_offset: %u, mbuf_len: %d, ds_high_drop: %ju\n\n",
+					ndrop, (uintmax_t)map->ds_map_start, map->ds_map_len,
+					map->mbuf_start, map->mbuf_offset, map->mbuf_start->m_len,
+					(uintmax_t)ds_high_drop);
+
+			} else {
+				/* Map has yet to be removed from the mp snd list, so we do so here
+				* before freeing the the map from memory, to prevent dangling pointers
+				* in the mp snd list. The map is no longer needed from this point. */
+				TAILQ_REMOVE(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+
+				mp_debug(DSMAP, 4, 0, "%s: snd_dsmap %p DELETED. map_len: "
+				    "%d, mbuf_start: %p, sf_seq_start: %u\n",
+				    __func__, map, map->ds_map_len, map->mbuf_start,
+				    map->sf_seq_start);
+
+				free(map, M_DSSMAP);
+			}
+
+			map = next_map;
+	     }
+
+
+	     mp_debug(DSMAP, 4, 0, "%s: Dropping %d bytes from socket "
+	         "buffer\n", __func__, ndrop);
+	     sbdrop(&mp->master_socket->so_snd, ndrop);
+	     mp->ds_map_min += ndrop;
+	     sowwakeup(mp->master_socket);
+	}
+
+}
+
+/*
+ * Accesses socket buffer on behalf on a subflow and returns a mapping
+ * into the send buffer than the subflow will transmit from.
+ *
+ * XXXNJW: currently just returns the size of the send buffer (i.e. no
+ * 'smarts' in what it allocates to a subflow)
+ */
+struct ds_map*
+mp_get_map(struct mpcb *mp) {
+	struct ds_map *map = NULL;
+	struct socket *so;
+	int map_length;
+
+	so = mp->master_socket;
+	SOCKBUF_LOCK(&so->so_snd);
+
+	/* If there are bytes in the send buff that could potentially be
+	 * sent
+	 * */
+	if(so->so_snd.sb_cc) {
+
+		//if (so->so_snd.sb_cc >= so->so_snd.sb_hiwat)
+		//	map_length = SB_NUNMAPPED(&so->so_snd, mp) / mp->subflow_cnt;
+		//else
+		//	map_length = SB_NUNMAPPED(&so->so_snd, mp);
+
+		/* the following line forces a max map_length of 2048
+		 * which is used in testing to spread the socket buffer
+		 * across more flows */
+		map_length = min(SB_NUNMAPPED(&so->so_snd, mp), 2048);
+
+		KASSERT (so->so_snd.sb_actual >= (mp->ds_map_max - mp->ds_map_min),
+			("%s: Negative map length\n", __func__));
+
+		if (map_length > 0) {
+			map = malloc(sizeof(struct ds_map), M_DSSMAP, M_NOWAIT|M_ZERO);
+
+			if (map) {
+				/*
+				 * XXXNJW: in future at this point want to decide how
+				 * many bytes are sent from the sockbuf rather than simply sbchars.
+				 */
+				map->mbuf_start = sbsndptr(&so->so_snd,
+					(mp->ds_map_max - mp->ds_map_min),
+					map_length, &map->mbuf_offset);
+
+				map->ds_map_start = mp->ds_map_max;
+				map->ds_map_len = map_length;
+
+				mp_debug(DSMAP, 4, 0, "%s: map %p, ds_map_start %ju, "
+					"ds_map_end %ju, mbuf_start %p, mb_offset: %u, offset: "
+					"%ju, maplen: %d, sbcc: %u, sb_mb: %p\n",
+				    __func__, map, (uintmax_t)map->ds_map_start,
+				    (uintmax_t)map->ds_map_start+map_length, map->mbuf_start,
+				    map->mbuf_offset, (uintmax_t)(mp->ds_map_max - mp->ds_snd_una),
+					map_length, so->so_snd.sb_cc,so->so_snd.sb_mb);
+				mp->ds_map_max += map_length;
+
+				// do ordered insert of map into list by ds_start value
+				/*
+				 * Insert the map in data-sequence order by finding an existing
+				 * map whose ds_start value is greater than or equal to the new
+				 * map. Insert the new map before this. If this map is not before
+				 * any existing maps, insert at the tail.
+				 */
+				struct ds_map *next_map;
+				TAILQ_FOREACH(next_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+					if (next_map->ds_map_start >= map->ds_map_start) {
+						TAILQ_INSERT_BEFORE(next_map, map, mp_ds_map_next);
+						mp_debug(DSMAP, 4, 0, "inserted map %p before map %p\n",
+						    map, next_map);
+						break;
+					}
+				}
+				if (next_map == NULL) {
+					mp_debug(DSMAP, 4, 0, "inserting map %p at tail of "
+					    "mp_ds_sndmaps, is mp_ds_sndmaps empty %d\n",
+					    map, TAILQ_EMPTY(&mp->mp_ds_sndmaps));
+					TAILQ_INSERT_TAIL(&mp->mp_ds_sndmaps, map, mp_ds_map_next);
+				}
+
+				/* XXX: DEBUG */
+				int total_mapped = 0;
+				TAILQ_FOREACH(next_map, &mp->mp_ds_sndmaps, mp_ds_map_next) {
+					total_mapped += next_map->ds_map_len;
+				}
+
+				KASSERT(total_mapped == mp->ds_map_max - mp->ds_map_min,
+						("total mapped not equal to mapped bytesl\n"));
+
+			}
+		}
+	}
+
+	SOCKBUF_UNLOCK(&so->so_snd);
+
+	return(map);
+}
+
+struct ds_map *
+mp_find_dsmap(struct tcpcb *tp, tcp_seq	seqnum)
+{
+	struct ds_map *map;
+	int new_map;
+
+	new_map = 0;
+
+	TAILQ_FOREACH(map, &tp->t_txdsmaps, sf_ds_map_next) {
+		if (seqnum >= map->sf_seq_start) {
+			if (seqnum >= (map->sf_seq_start + map->ds_map_len)) {
+				/* seqnum should be equal to tp->snd_max but snd_max may not have
+				 * been updated before this function has been called. */
+				KASSERT(seqnum == (map->sf_seq_start + map->ds_map_len) &&
+					map->flags & MAPF_IS_SENT,
+				    ("%s: sqn %u is greater than highest map\n", __func__,
+				    seqnum));
+				new_map = 1;
+			}
+			break;
+		}
+	}
+
+	if (map == NULL || new_map) {
+		if (map == NULL)
+			KASSERT(TAILQ_EMPTY(&tp->t_txdsmaps),
+			    ("%s: %u below sf_seq_start of oldest una map",
+			    __func__, seqnum));
+
+		map = mp_get_map(tp->t_mpcb);
+		if (map) {
+			map->sf_seq_start = seqnum;
+			TAILQ_INSERT_HEAD(&tp->t_txdsmaps, map, sf_ds_map_next);
+			if (tp->sf_flags & SFF_DATA_WAIT) {
+				tp->sf_flags &= ~SFF_DATA_WAIT;
+				atomic_subtract_acq_int(&tp->t_mpcb->data_wait_count, 1);
+			}
+			//if (atomic_load_acq_int(&tp->t_mpcb->data_wait_count) > 1)
+			//	taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->data_task);
+		} else {
+			if (!(tp->sf_flags & SFF_DATA_WAIT)) {
+				tp->sf_flags |= SFF_DATA_WAIT;
+				atomic_add_acq_int(&tp->t_mpcb->data_wait_count, 1);
+			}
+		}
+	}
+
+	return (map);
+}
+
+void
+mp_subflow_is_disconnected(struct tcpcb *tp) {
+
+	struct mpcb *mp = tp->t_mpcb;
+	struct tcpcb *sf_tp;
+	int all_closed = 1;
+
+	INP_WLOCK_ASSERT(tp->t_inpcb);
+
+	SLIST_FOREACH(sf_tp, &mp->tp_list, next_subflow) {
+		if (sf_tp == tp)
+			continue;
+
+		/*
+		 * The calling thread holds a write lock on the tp
+		 * that is just transitioning to FIN_WAIT_2. When this function
+		 * is run from a different context it will not race with this
+		 * thread when checking its state.
+		 */
+		INP_RLOCK(sf_tp->t_inpcb);
+		if (sf_tp->t_state < TCPS_FIN_WAIT_2)
+			all_closed = 0;
+		INP_RUNLOCK(sf_tp->t_inpcb);
+		if (!all_closed)
+			break;
+	}
+
+	if(all_closed)
+		soisdisconnected(mp->master_socket);
+
+}
+
+void
+mp_process_local_key(struct mpcb *mp, uint64_t local_key)
+{
+	uint8_t digest[20];
+	mp_do_sha_hash(digest, (uint8_t*) &local_key, sizeof(local_key));
+
+	mp->ds_idsn = mp_new_idsn(digest);
+	mp->local_key = local_key;
+
+	/* As linux does this, we need to do it for interop */
+	mp->ds_idsn = htobe64(mp->ds_idsn);
+	mp->local_token = mp_get_token(digest);
+
+}
+void
+mp_process_remote_key(struct mpcb *mp, uint64_t remote_key)
+{
+	uint8_t digest[20];
+	char buf[256];
+
+	mp_do_sha_hash(digest, (uint8_t*) &remote_key, sizeof(remote_key));
+	mp->ds_idsr = mp_new_idsn(digest);
+	mp->ds_idsr = htobe64(mp->ds_idsr);
+	mp->remote_token = mp_get_token(digest);
+	mp->remote_key = remote_key;
+
+	mp_debug(MPSESSION, 4, 0, "%s: idsr: %ju : %u\n", __func__,
+		(uintmax_t)mp->ds_idsr, (uint32_t)mp->ds_idsr);
+
+	/* debug output from hash */
+
+	btohex(buf, sizeof(buf), digest, sizeof(digest), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "SHA1(key) = 0x%s\n", buf);
+
+	btohex(buf, sizeof(buf), (uint8_t *)&mp->ds_map_max,
+			sizeof(mp->ds_map_max), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "ds_map_max = 0x%s\n", buf);
+	mp_debug(MPSESSION, 4, 0, "ds_map_max = %u\n", (uint32_t)mp->ds_map_max);
+
+	btohex(buf, sizeof(buf), (uint8_t *)&mp->ds_idsn,
+			sizeof(mp->ds_idsn), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "local idsn = 0x%s\n", buf);
+	mp_debug(MPSESSION, 4, 0, "local idsn = %u\n", (uint32_t)mp->ds_idsn);
+
+	btohex(buf, sizeof(buf), (uint8_t *)&mp->ds_rcv_nxt,
+			sizeof(mp->ds_rcv_nxt), BTOHEX_MSBLTOR);
+	mp_debug(MPSESSION, 4, 0, "remote idsn = 0x%s\n", buf);
+	mp_debug(MPSESSION, 4, 0, "remote idsn = %u\n", (uint32_t)mp->ds_rcv_nxt);
+}
+
+
+SYSCTL_VNET_PROC(_net_inet_tcp_mptcp, OID_AUTO, mp_addresses, CTLTYPE_STRING|CTLFLAG_RW,
+    NULL, 0, mp_addresses, "A", "extra addresses to be used in Multipath TCP connections");
+
+SYSCTL_VNET_PROC(_net_inet_tcp_mptcp, OID_AUTO, mp_debug, CTLTYPE_STRING|CTLFLAG_RW,
+    NULL, 0, mp_debug_sysctl_handler, "A", "Enable debugging output for mptcp");
